scriptname ASGQuest extends SKI_ConfigBase

import debug

; SCRIPT VERSION ----------------------------------------------------------------------------------
int function GetVersion()
	return 3 ; Default version
endFunction

; VARIABLES ---------------------------------------------------------------------------------------
GlobalVariable property ASGOnlyBlack auto
GlobalVariable property ASGOnlyFull auto
GlobalVariable property ASGSilent auto
int blackOID
int fullOID
int silentOID
bool onlyBlack
bool onlyFull
bool silent

; INITIALIZATION ----------------------------------------------------------------------------------
; @implements SKI_ConfigBase
event OnConfigInit()
	{Called when this config menu is initialized}
	onlyBlack = true
	onlyFull = true
	silent = true
	if(ASGOnlyBlack.GetValueInt() != 1)
		onlyBlack = false
	endif
	if(ASGOnlyFull.GetValueInt() != 1)
		onlyFull = false
	endif
	if(ASGSilent.GetValueInt() != 1)
		silent = false
		ASGSilent.SetValueInt(2)
	endif
	debug.trace("ASGQuest init - black: "+onlyBlack+" GlobalBlack: "+ASGOnlyBlack.GetValueInt()+" full: "+onlyFull+" GlobalFull: "+ASGOnlyFull.GetValueInt()+" silent: "+silent+" GlobalSilent: "+ASGSilent.GetValueInt())
	; ...
endEvent

; EVENTS ------------------------------------------------------------------------------------------
; @implements SKI_ConfigBase
event OnPageReset(string a_page)
	{Called when a new page is selected, including the initial empty page}
	SetCursorFillMode(TOP_TO_BOTTOM) 
	onlyBlack = true
	onlyFull = true
	silent = true
	if(ASGOnlyBlack.GetValueInt() != 1)
		onlyBlack = false
	endif
	if(ASGOnlyFull.GetValueInt() != 1)
		onlyFull = false
	endif
	if(ASGSilent.GetValueInt() != 1)
		silent = false
		ASGSilent.SetValueInt(2)
	endif
	debug.trace("ASGQuest page reset - black: "+onlyBlack+" GlobalBlack: "+ASGOnlyBlack.GetValueInt()+" full: "+onlyFull+" GlobalFull: "+ASGOnlyFull.GetValueInt()+" silent: "+silent+" GlobalSilent: "+ASGSilent.GetValueInt())
	;blackOID = AddToggleOption("Only Black Souls", onlyBlack)
	blackOID = AddToggleOption("$ASGBlackOption", onlyBlack)
	;fullOID = AddToggleOption("Filled Star", onlyFull)
	fullOID = AddToggleOption("$ASGFilledOption", onlyFull)
	;silentOID = AddToggleOption("Shut up!", silent)
	silentOID = AddToggleOption("$ASGSilentOption", silent)
	; ...
endEvent

event OnOptionSelect(int option)
	if(option == blackOID)
		onlyBlack = !onlyBlack
		if(onlyBlack)
			ASGOnlyBlack.SetValueInt(1)
		else
			ASGOnlyBlack.SetValueInt(0)
		endif
		SetToggleOptionValue(option, onlyBlack)
		debug.trace("ASGQuest set black - black: "+onlyBlack+" GlobalBlack: "+ASGOnlyBlack.GetValueInt())
	elseIf(option == fullOID)
		onlyFull = !onlyFull
		if(onlyFull)
			ASGOnlyFull.SetValueInt(1)
		else
			ASGOnlyFull.SetValueInt(0)
		endif
		SetToggleOptionValue(option, onlyFull)
		debug.trace("ASGQuest set full - full: "+onlyFull+" GlobalFull: "+ASGOnlyFull.GetValueInt())
	elseIf(option == silentOID)
		silent = !silent
		if(silent)
			ASGSilent.SetValueInt(1)
		else
			ASGSilent.SetValueInt(2)
		endif
		SetToggleOptionValue(option, silent)
		debug.trace("ASGQuest set silent - silent: "+silent+" GlobalSilent: "+ASGSilent.GetValueInt())
	endIf
endEvent

event OnOptionHighlight(int option)
	if(option == blackOID)
		;SetInfoText("Black Gems and Black Star can only hold Black Souls\nDefault: True")
		SetInfoText("$ASGBlackInfo")
	elseIf(option == fullOID)
		;SetInfoText("Azura's Star and Black Star cannot hold smaller than Grand Souls\nDefault: False")
		SetInfoText("$ASGFilledInfo")
	elseIf(option == silentOID)
		;SetInfoText("Turn off ASG Soul Captured messages\nDefault: False")
		SetInfoText("$ASGSilentInfo")
	endIf
endEvent
