Scriptname ASGThreadLock extends Quest
{Makes sure only one Soul Trap gets called at a time.
Needed because ASGM removes soul gems from Trapper's
inventory while running, so we need to be certain those
gems are put back before we allow another Soul Trap
occurs.}

import debug

Actor[] Trappers
int ActiveTrappers = 0

;Create the array used to track active Trappers.
Event OnInit()
	Trappers = new Actor[128]
	debug.trace("ASGThreadLock - Trapper Array created")
EndEvent

String function intToHex (int num)
	int remainder
	String result = ""
	;String[] hex = ["0","1","2","3,"4","5","6","7","8","9","A","B","C","D","E","F"]
	String[] hex = new String[16]
	;assign the individual parts of hex[] since we can't do it all at once.
	int i = 0
	while (i < 10)
		hex[i] = ""+i
		i+=1
	endWhile
	hex[10] = "A"
	hex[11] = "B"
	hex[12] = "C"
	hex[13] = "D"
	hex[14] = "E"
	hex[15] = "F"
	
	;The actual conversion from int to hex string	
	while (num > 0)
		remainder = num % 16
		result = hex[remainder] + result
		num = num/16
	endWhile
	return result
endFunction

;Determine if Trapper has a Soul Trap happening already,
;and grant lock if not, adding Trapper to the array.
Bool Function AcquireLock(Actor Trapper)
	if Trappers.find(Trapper) >= 0
		return Trapper == None
	else
		Trappers[ActiveTrappers] = Trapper
		ActiveTrappers += 1
		debug.trace("ASGThreadLock - Lock granted to "+intToHex(Trapper.GetFormID()))
		return True
	endif
EndFunction

;Remove Trapper from the array.
Function ReleaseLock(Actor Trapper)
	int LockIndex = Trappers.find(Trapper)
	if LockIndex >= 0
		Trappers[LockIndex] = None
		ActiveTrappers -= 1
		Trappers[LockIndex] = Trappers[ActiveTrappers]
		Trappers[ActiveTrappers] = None
	endif
	debug.trace("ASGThreadLock - "+intToHex(Trapper.GetFormID())+" Lock released.")
EndFunction 